/* $ANTLR 2.7.5 (20050201): "parser.g" -> "ASTParser.cpp"$ */
#include "ASTParser.hpp"
#include <antlr/Token.hpp>
#include <antlr/AST.hpp>
#include <antlr/NoViableAltException.hpp>
#include <antlr/MismatchedTokenException.hpp>
#include <antlr/SemanticException.hpp>
#include <antlr/BitSet.hpp>
#line 593 "parser.g"

	#include <stack>
	
	typedef vector<int>					AddrVec;
	typedef pair<AddrVec, AddrVec>	BreakContinuePair;
	typedef vector<antlr::RefAST>		TopLevelCallVector;
	
	Generator						gen;
	stack<BreakContinuePair>	loopStack;
	Scope								scope;

#line 22 "ASTParser.cpp"
ASTParser::ASTParser()
	: ANTLR_USE_NAMESPACE(antlr)TreeParser() {
}

void ASTParser::start(RefASTNodeExt _t) {
	RefASTNodeExt start_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt p = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt programName = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 642 "parser.g"
	
		Symbol* sym = 0;
	
#line 35 "ASTParser.cpp"
	
	RefASTNodeExt __t171 = _t;
	p = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),PROGRAM);
	_t = _t->getFirstChild();
	programName = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),IDENT);
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 649 "parser.g"
		
						// we need this GOTO to jump over all functions into main block
						gen.genAsm(SymbolicInstr(Compiler::GOTO, Constant(0)));
		
						scope.enter(0);
					
#line 52 "ASTParser.cpp"
	}
	{ // ( ... )*
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		switch ( _t->getType()) {
		case FUNCTION:
		{
			functionDef(_t);
			_t = _retTree;
			break;
		}
		case FORWARD:
		{
			forward(_t);
			_t = _retTree;
			break;
		}
		case DECL:
		{
			sym=declaration(_t);
			_t = _retTree;
			break;
		}
		default:
		{
			goto _loop173;
		}
		}
	}
	_loop173:;
	} // ( ... )*
	if ( inputState->guessing==0 ) {
#line 658 "parser.g"
		
						gen.backpatchAt(0, Constant(gen.getCodeSize()));
					
#line 90 "ASTParser.cpp"
	}
	block(_t);
	_t = _retTree;
	_t = __t171;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 665 "parser.g"
		
					gen.patchFunctionCalls(scope.top());
					scope.exit();
					gen.genAsm(SymbolicInstr(Compiler::NOP));
					gen.generateAssembly(programName->getText(), scope.allSymbolTables);
					
					cout << "Generated " << programName->getText() << OUTPUT_FILE_EXT << endl;
				
#line 106 "ASTParser.cpp"
	}
	_retTree = _t;
}

void ASTParser::functionDef(RefASTNodeExt _t) {
	RefASTNodeExt functionDef_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt f = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 736 "parser.g"
	
		Symbol* fn = 0;
		SymbolTable* localST = 0;
	
#line 119 "ASTParser.cpp"
	
	RefASTNodeExt __t183 = _t;
	f = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),FUNCTION);
	_t = _t->getFirstChild();
	fn=declaration(_t,false, true);
	_t = _retTree;
	if ( inputState->guessing==0 ) {
#line 745 "parser.g"
		
						fn->index = gen.getCodeSize();
						fn->isFunction = true;
						fn->localAddressCounter = fn->type.getSize(WORD, TypeAttr::ARRAY_AS_POINTER) * WORD_SIZE;
						
						gen.currentFunction = fn;
						
						scope.resetSpace();				// we need to know the space size for local data
						localST = scope.enter(0);		// create the local symbol table
						localST->function = fn;
					
#line 140 "ASTParser.cpp"
	}
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case PARAMS:
	{
		paramList(_t,fn);
		_t = _retTree;
		break;
	}
	case BLOCK:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	if ( inputState->guessing==0 ) {
#line 759 "parser.g"
		
						bool result = scope.getTopLevel()->addFunction(fn);
		
						ERROR_IF(!result, f->getLine(), "Illegal function definition");
					
#line 169 "ASTParser.cpp"
	}
	block(_t,false, fn);
	_t = _retTree;
	_t = __t183;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 768 "parser.g"
		
					fn->localSpace = scope.exit();
					fn->isFullFunctionDef = true;
		
					if (fn->type.getSize() == 0) {	// generate return code for void function
						// ### load the return address
						gen.genAsm(SymbolicInstr(Compiler::LOAD, 
															Constant((fn->localSpace + fn->type.getSize(WORD, TypeAttr::ARRAY_AS_POINTER)) * WORD_SIZE),
															INT_CODE, 
															SymbolicInstr::OPERAND));
		
						// ### jump to the return address
						gen.genAsm(SymbolicInstr(Compiler::GOTOI));
		
						gen.currentFunction = 0;
					}
		
					// ### backpatch all instructions that need the function space info
					
					gen.backpatch(fn, AFTER_FN_BODY, fn->localSpace);
					gen.currentFunction = 0;
					gen.hasReturnStatement = false;
				
#line 200 "ASTParser.cpp"
	}
	_retTree = _t;
}

void ASTParser::forward(RefASTNodeExt _t) {
	RefASTNodeExt forward_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt f = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 677 "parser.g"
	
		Symbol* fn = 0;
		SymbolTable* localST = 0;
		TypeAttr type;
		Symbol::ParamVector params;
	
#line 215 "ASTParser.cpp"
	
	RefASTNodeExt __t175 = _t;
	RefASTNodeExt tmp1_AST_in = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),FORWARD);
	_t = _t->getFirstChild();
	RefASTNodeExt __t176 = _t;
	f = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),FUNCTION);
	_t = _t->getFirstChild();
	fn=declaration(_t,false, true);
	_t = _retTree;
	if ( inputState->guessing==0 ) {
#line 689 "parser.g"
		
							fn->isFunction = true;
							fn->isForwardedFunction = true;
						
#line 233 "ASTParser.cpp"
	}
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case PARAMS:
	{
		RefASTNodeExt __t178 = _t;
		RefASTNodeExt tmp2_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),PARAMS);
		_t = _t->getFirstChild();
		{ // ( ... )+
		int _cnt180=0;
		for (;;) {
			if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				_t = ASTNULL;
			if ((_t->getType() == TYPE)) {
				type=typeSpec(_t);
				_t = _retTree;
				if ( inputState->guessing==0 ) {
#line 697 "parser.g"
					
												fn->fwdParamTypes.push_back(type);
											
#line 258 "ASTParser.cpp"
				}
			}
			else {
				if ( _cnt180>=1 ) { goto _loop180; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));}
			}
			
			_cnt180++;
		}
		_loop180:;
		}  // ( ... )+
		if ( inputState->guessing==0 ) {
#line 702 "parser.g"
			
										bool result = scope.getTopLevel()->addFunction(fn);
										
										ERROR_IF(!result, f->getLine(), "Illegal forward declaration");
									
#line 276 "ASTParser.cpp"
		}
		_t = __t178;
		_t = _t->getNextSibling();
		break;
	}
	case 3:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	_t = __t176;
	_t = _t->getNextSibling();
	_t = __t175;
	_t = _t->getNextSibling();
	_retTree = _t;
}

Symbol*  ASTParser::declaration(RefASTNodeExt _t,
	bool isParameter, bool createSymbol
) {
#line 1188 "parser.g"
	Symbol* sym = 0;
#line 304 "ASTParser.cpp"
	RefASTNodeExt declaration_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt node = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt id = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1188 "parser.g"
	
		TypeAttr type;
	
#line 312 "ASTParser.cpp"
	
	RefASTNodeExt __t227 = _t;
	node = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),DECL);
	_t = _t->getFirstChild();
	type=typeSpec(_t);
	_t = _retTree;
	id = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),IDENT);
	_t = _t->getNextSibling();
	_t = __t227;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 1196 "parser.g"
		
					if (createSymbol) {
						// this will be deleted by the SymbolTable destructor
						sym = new Symbol(id->getText(), scope.top()->getID(), type);
					}
					else {
						sym = scope.top()->addSymbol(id->getText(), type, isParameter);
						
						ERROR_IF(sym == 0, node->getLine(), "Duplicate identifier");
						
						sym->isLocal = gen.currentFunction != 0;
					}
				
#line 340 "ASTParser.cpp"
	}
	_retTree = _t;
	return sym;
}

void ASTParser::block(RefASTNodeExt _t,
	bool createScope, Symbol* function
) {
	RefASTNodeExt block_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt b = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt __t203 = _t;
	b = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),BLOCK);
	_t = _t->getFirstChild();
	if ( inputState->guessing==0 ) {
#line 913 "parser.g"
		
					// This code verifies that a non-void function returns a value. It only
					// scans the outermost block of the function; it doesn't check all the
					// control paths to ensure that all of them return a value (which would
					// be the right way to do this). Therefore, the compiler requires all
					// non-void functions to have a return statement as the last statement
					// of the outermost block. It also verifies that there are no 
					// statements following a return statement.
		
					bool hasReturnStatement = false;
					antlr::RefAST node = b->getFirstChild();
					while (node) {
						if (node->getType() == RETURN) {
							hasReturnStatement = true;
		
							// the return statement must be the last statement in the block
							ERROR_IF(node->getNextSibling() != 0,
										b->getLine(), "The return statement is not the last statement in the block");
							
							break;
						}
						
						node = node->getNextSibling();
					}
						
					// make sure that non-void functions have a return statement
					ERROR_IF(function && function->type.getSize() > 0 && !hasReturnStatement,
								b->getLine(), "The outermost block must have 'return' as the last statement");
				
#line 387 "ASTParser.cpp"
	}
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case RETURN:
	case IF:
	case CONTINUE:
	case BREAK:
	case WRITE:
	case WRITELN:
	case READ:
	case DECL:
	case BLOCK:
	case CAST:
	case CONST:
	case CALL:
	case LOOPHDR:
	case INC:
	case DEC:
	case IDENT:
	case ASSIGN:
	case LBRACKET:
	case REF:
	case OR:
	case AND:
	case NEQ:
	case EQ:
	case TK_LT:
	case GT:
	case LE:
	case GE:
	case PLUS:
	case MINUS:
	case STAR:
	case DIVIDE:
	case MODULO:
	case NOT:
	case ADDR:
	{
		if ( inputState->guessing==0 ) {
#line 944 "parser.g"
			
								// create the symbol table for the block
								if (createScope) scope.enter(gen.currentFunction);
			
								// find all top-level function calls (if any)
								findTopLevelCalls(b);
							
#line 437 "ASTParser.cpp"
		}
		statementList(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 954 "parser.g"
				// the end of block - go back to the outer symbol table (if any)
								if (createScope) scope.exit();
							
#line 446 "ASTParser.cpp"
		}
		break;
	}
	case 3:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	_t = __t203;
	_t = _t->getNextSibling();
	_retTree = _t;
}

TypeAttr  ASTParser::typeSpec(RefASTNodeExt _t) {
#line 1237 "parser.g"
	TypeAttr t;
#line 468 "ASTParser.cpp"
	RefASTNodeExt typeSpec_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt typeName = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1237 "parser.g"
	
		vector<int> dim;
	
#line 475 "ASTParser.cpp"
	
	RefASTNodeExt __t233 = _t;
	RefASTNodeExt tmp3_AST_in = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),TYPE);
	_t = _t->getFirstChild();
	typeName = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),IDENT);
	_t = _t->getNextSibling();
	{ // ( ... )*
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_t->getType() == REF)) {
			RefASTNodeExt tmp4_AST_in = _t;
			match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),REF);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 1247 "parser.g"
				
									t.setAsPointer();
									t.increaseRefLevel();
								
#line 498 "ASTParser.cpp"
			}
		}
		else {
			goto _loop235;
		}
		
	}
	_loop235:;
	} // ( ... )*
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case ARRAY:
	{
		dim=arrayTypeSpec(_t);
		_t = _retTree;
		break;
	}
	case 3:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	_t = __t233;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 1256 "parser.g"
		
					bool typeExists = t.setTypeName(typeName->getText(), dim);
		
					ERROR_IF(!typeExists, typeName->getLine(), "Undefined type");
				
#line 537 "ASTParser.cpp"
	}
	_retTree = _t;
	return t;
}

void ASTParser::statement(RefASTNodeExt _t) {
	RefASTNodeExt statement_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case CONTINUE:
	{
		continueStmt(_t);
		_t = _retTree;
		break;
	}
	case BREAK:
	{
		breakStmt(_t);
		_t = _retTree;
		break;
	}
	case BLOCK:
	{
		block(_t);
		_t = _retTree;
		break;
	}
	case LOOPHDR:
	{
		loop(_t);
		_t = _retTree;
		break;
	}
	case IF:
	{
		ifElse(_t);
		_t = _retTree;
		break;
	}
	case RETURN:
	{
		returnExpression(_t);
		_t = _retTree;
		break;
	}
	case DECL:
	case CAST:
	case CONST:
	case CALL:
	case INC:
	case DEC:
	case IDENT:
	case ASSIGN:
	case LBRACKET:
	case REF:
	case OR:
	case AND:
	case NEQ:
	case EQ:
	case TK_LT:
	case GT:
	case LE:
	case GE:
	case PLUS:
	case MINUS:
	case STAR:
	case DIVIDE:
	case MODULO:
	case NOT:
	case ADDR:
	{
		simpleStatement(_t);
		_t = _retTree;
		break;
	}
	case WRITE:
	case WRITELN:
	case READ:
	{
		inputOutputStmt(_t);
		_t = _retTree;
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	_retTree = _t;
}

void ASTParser::continueStmt(RefASTNodeExt _t) {
	RefASTNodeExt continueStmt_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt n = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	n = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),CONTINUE);
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 881 "parser.g"
		
					ERROR_IF(loopStack.size() == 0, n->getLine(), "The 'continue' statement can be used only inside a loop body");
		
					BreakContinuePair& bcPair = loopStack.top();
					AddrVec* vec = &(bcPair.second);
					vec->push_back(gen.getCodeSize());
					gen.genAsm(SymbolicInstr(Compiler::GOTO, Constant(0)));
				
#line 648 "ASTParser.cpp"
	}
	_retTree = _t;
}

void ASTParser::breakStmt(RefASTNodeExt _t) {
	RefASTNodeExt breakStmt_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt n = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	n = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),BREAK);
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 897 "parser.g"
		
					ERROR_IF(loopStack.size() == 0, n->getLine(), "The 'break' statement can be used only inside a loop body");
		
					BreakContinuePair& bcPair = loopStack.top();
					AddrVec* vec = &(bcPair.first);
					vec->push_back(gen.getCodeSize());
					gen.genAsm(SymbolicInstr(Compiler::GOTO, Constant(0)));
				
#line 670 "ASTParser.cpp"
	}
	_retTree = _t;
}

void ASTParser::loop(RefASTNodeExt _t) {
	RefASTNodeExt loop_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt l = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt init = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt iter = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1016 "parser.g"
	
		TypeAttr t;
		int loopStart = 0;
		int backpatchInstrLoc = 0;
		bool condExists = false;
		bool statementExists = false;
		bool iterationExists = false;
		int loopID = gen.getCodeSize();
		int loopIterAddr = 0;
	
#line 691 "ASTParser.cpp"
	
	RefASTNodeExt __t212 = _t;
	l = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),LOOPHDR);
	_t = _t->getFirstChild();
	if ( inputState->guessing==0 ) {
#line 1030 "parser.g"
		
						findTopLevelCalls(l);
		
						// Add the vectors to the loop stack that will serve as placeholder
						// for BREAK/CONTINUE addresses. These addresses will then be
						// back-patched with the address of the first instruction following
						// the loop (in case of BREAK) or the beginning of the iteration
						// part (in case of CONTINUE).
						//
						loopStack.push(BreakContinuePair());
		
						// Define the scope for the loop - any declarations in a loop
						// header are visible only inside the loop header and body.
						//
						scope.enter(gen.currentFunction);
					
#line 715 "ASTParser.cpp"
	}
	RefASTNodeExt __t213 = _t;
	init = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),INIT);
	_t = _t->getFirstChild();
	if ( inputState->guessing==0 ) {
#line 1049 "parser.g"
		
							findTopLevelCalls(init);
						
#line 726 "ASTParser.cpp"
	}
	{ // ( ... )*
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_tokenSet_0.member(_t->getType()))) {
			simpleStatement(_t);
			_t = _retTree;
		}
		else {
			goto _loop215;
		}
		
	}
	_loop215:;
	} // ( ... )*
	_t = __t213;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 1056 "parser.g"
		
						loopStart = gen.getCodeSize();
					
#line 750 "ASTParser.cpp"
	}
	RefASTNodeExt __t216 = _t;
	RefASTNodeExt tmp5_AST_in = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),COND);
	_t = _t->getFirstChild();
	{ // ( ... )*
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_tokenSet_1.member(_t->getType()))) {
			t=expression(_t);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 1064 "parser.g"
				
										condExists = true;
										backpatchInstrLoc = gen.getCodeSize();
										gen.genAsm(SymbolicInstr(Compiler::IFFALSE, Constant(0)));
									
#line 770 "ASTParser.cpp"
			}
		}
		else {
			goto _loop218;
		}
		
	}
	_loop218:;
	} // ( ... )*
	_t = __t216;
	_t = _t->getNextSibling();
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case RETURN:
	case IF:
	case CONTINUE:
	case BREAK:
	case WRITE:
	case WRITELN:
	case READ:
	case DECL:
	case BLOCK:
	case CAST:
	case CONST:
	case CALL:
	case LOOPHDR:
	case INC:
	case DEC:
	case IDENT:
	case ASSIGN:
	case LBRACKET:
	case REF:
	case OR:
	case AND:
	case NEQ:
	case EQ:
	case TK_LT:
	case GT:
	case LE:
	case GE:
	case PLUS:
	case MINUS:
	case STAR:
	case DIVIDE:
	case MODULO:
	case NOT:
	case ADDR:
	{
		statement(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1073 "parser.g"
			statementExists = true;
#line 826 "ASTParser.cpp"
		}
		break;
	}
	case EMPTY:
	{
		RefASTNodeExt tmp6_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),EMPTY);
		_t = _t->getNextSibling();
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	RefASTNodeExt __t220 = _t;
	iter = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),ITER);
	_t = _t->getFirstChild();
	if ( inputState->guessing==0 ) {
#line 1080 "parser.g"
		
							findTopLevelCalls(iter);
						
#line 852 "ASTParser.cpp"
	}
	{ // ( ... )*
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_tokenSet_0.member(_t->getType()))) {
			if ( inputState->guessing==0 ) {
#line 1085 "parser.g"
				
										iterationExists = true; 
				
										// might be needed to backpatch CONTINUE statement
										//
										loopIterAddr = gen.getCodeSize();
									
#line 868 "ASTParser.cpp"
			}
			simpleStatement(_t);
			_t = _retTree;
		}
		else {
			goto _loop222;
		}
		
	}
	_loop222:;
	} // ( ... )*
	_t = __t220;
	_t = _t->getNextSibling();
	_t = __t212;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 1098 "parser.g"
		
					if (statementExists || condExists || iterationExists) {
						gen.genAsm(SymbolicInstr(Compiler::GOTO, Constant(loopStart)));
					}
		
					if (condExists) {
						gen.backpatchAt(backpatchInstrLoc, Constant(gen.getCodeSize()));
					}
		
					// get the loop's stack and backpatch BREAK/CONTINUE (if needed)
					
					BreakContinuePair& bcPair = loopStack.top();
					AddrVec breakVec = bcPair.first;
					AddrVec contVec = bcPair.second;
					
					int backpatchLoc = 0;
					
					// ... check for BREAK
					//
					for (size_t i = 0;  i < breakVec.size();  ++i) {
						backpatchLoc = breakVec[i];
						gen.backpatchAt(backpatchLoc, Constant(gen.getCodeSize()));
					}
					
					// ... check for CONTINUE
					//
					for (size_t i = 0;  i < contVec.size();  ++i) {
						backpatchLoc = contVec[i];
						gen.backpatchAt(backpatchLoc, Constant(loopIterAddr));
					}
		
					loopStack.pop();
					scope.exit();
				
#line 920 "ASTParser.cpp"
	}
	_retTree = _t;
}

void ASTParser::ifElse(RefASTNodeExt _t) {
	RefASTNodeExt ifElse_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt n = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1136 "parser.g"
	
		TypeAttr t;
		int backpatchCond = 0;
		int backpatchThen = 0;
		bool elseExists = false;
	
#line 935 "ASTParser.cpp"
	
	RefASTNodeExt __t224 = _t;
	n = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),IF);
	_t = _t->getFirstChild();
	if ( inputState->guessing==0 ) {
#line 1146 "parser.g"
		
						findTopLevelCalls(n, true);
					
#line 946 "ASTParser.cpp"
	}
	t=expression(_t);
	_t = _retTree;
	if ( inputState->guessing==0 ) {
#line 1152 "parser.g"
		
						backpatchCond = gen.getCodeSize();
						gen.genAsm(SymbolicInstr(Compiler::IFFALSE, Constant(0)));
					
#line 956 "ASTParser.cpp"
	}
	statement(_t);
	_t = _retTree;
	if ( inputState->guessing==0 ) {
#line 1159 "parser.g"
		
						backpatchThen = gen.getCodeSize();
						gen.genAsm(SymbolicInstr(Compiler::GOTO, Constant(0)));
					
#line 966 "ASTParser.cpp"
	}
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case RETURN:
	case IF:
	case CONTINUE:
	case BREAK:
	case WRITE:
	case WRITELN:
	case READ:
	case DECL:
	case BLOCK:
	case CAST:
	case CONST:
	case CALL:
	case LOOPHDR:
	case INC:
	case DEC:
	case IDENT:
	case ASSIGN:
	case LBRACKET:
	case REF:
	case OR:
	case AND:
	case NEQ:
	case EQ:
	case TK_LT:
	case GT:
	case LE:
	case GE:
	case PLUS:
	case MINUS:
	case STAR:
	case DIVIDE:
	case MODULO:
	case NOT:
	case ADDR:
	{
		if ( inputState->guessing==0 ) {
#line 1165 "parser.g"
			
								elseExists = true;
								gen.backpatchAt(backpatchCond, Constant(gen.getCodeSize()));
							
#line 1013 "ASTParser.cpp"
		}
		statement(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1172 "parser.g"
			
								gen.backpatchAt(backpatchThen, Constant(gen.getCodeSize()));
							
#line 1022 "ASTParser.cpp"
		}
		break;
	}
	case 3:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	if ( inputState->guessing==0 ) {
#line 1177 "parser.g"
		
						if (! elseExists) {
							gen.removeLastInstr();		// no ELSE, so we don't need the GOTO to jump over it
							gen.backpatchAt(backpatchCond, Constant(gen.getCodeSize()));
						}
					
#line 1044 "ASTParser.cpp"
	}
	_t = __t224;
	_t = _t->getNextSibling();
	_retTree = _t;
}

void ASTParser::returnExpression(RefASTNodeExt _t) {
	RefASTNodeExt returnExpression_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt r = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 970 "parser.g"
	
		TypeAttr t;
		bool hasExpression = false;
	
#line 1059 "ASTParser.cpp"
	
	RefASTNodeExt __t209 = _t;
	r = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),RETURN);
	_t = _t->getFirstChild();
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case CAST:
	case CONST:
	case CALL:
	case IDENT:
	case LBRACKET:
	case REF:
	case OR:
	case AND:
	case NEQ:
	case EQ:
	case TK_LT:
	case GT:
	case LE:
	case GE:
	case PLUS:
	case MINUS:
	case STAR:
	case DIVIDE:
	case MODULO:
	case NOT:
	case ADDR:
	{
		t=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 980 "parser.g"
			
								hasExpression = true;
							
#line 1098 "ASTParser.cpp"
		}
		break;
	}
	case 3:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	_t = __t209;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 986 "parser.g"
		
						ERROR_IF(! gen.currentFunction, r->getLine(), "The 'return' statement cannot be used outside of a function body");
					
						ERROR_IF(gen.currentFunction->type.getSize() > 0 && !hasExpression,
									r->getLine(), "Non-void functions must return a value");
						
						ERROR_IF(gen.currentFunction->type.getSize() == 0 && hasExpression,
									r->getLine(), "Void functions cannot return a value");
		
						gen.hasReturnStatement = true;
		
						struct SetVal: public IBackpatch {
							SetVal(int p, int v, Symbol* sym, BackpatchTime when): IBackpatch(p, v, sym, when) {}
							int value(int x) const { return initial + x * WORD_SIZE; }
						};
					
						// ### load the return address
						gen.bp.push_back(new SetVal(gen.getCodeSize(), 
																gen.currentFunction->type.getSize(WORD, TypeAttr::ARRAY_AS_POINTER) * WORD_SIZE,
																gen.currentFunction, 
																AFTER_FN_BODY));
						gen.genAsm(SymbolicInstr(Compiler::LOAD, Constant(0), INT_CODE, SymbolicInstr::OPERAND));
						
						// ### jump to the return address
						gen.genAsm(SymbolicInstr(Compiler::GOTOI));
					
#line 1142 "ASTParser.cpp"
	}
	_retTree = _t;
}

void ASTParser::simpleStatement(RefASTNodeExt _t) {
	RefASTNodeExt simpleStatement_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
#line 1265 "parser.g"
	
		TypeAttr t;
		Symbol* sym;
	
#line 1154 "ASTParser.cpp"
	
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case DECL:
	{
		sym=declaration(_t);
		_t = _retTree;
		break;
	}
	case INC:
	case DEC:
	{
		incDec(_t);
		_t = _retTree;
		break;
	}
	case ASSIGN:
	{
		assignment(_t);
		_t = _retTree;
		break;
	}
	case CAST:
	case CONST:
	case CALL:
	case IDENT:
	case LBRACKET:
	case REF:
	case OR:
	case AND:
	case NEQ:
	case EQ:
	case TK_LT:
	case GT:
	case LE:
	case GE:
	case PLUS:
	case MINUS:
	case STAR:
	case DIVIDE:
	case MODULO:
	case NOT:
	case ADDR:
	{
		t=expression(_t);
		_t = _retTree;
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	_retTree = _t;
}

void ASTParser::inputOutputStmt(RefASTNodeExt _t) {
	RefASTNodeExt inputOutputStmt_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
#line 820 "parser.g"
	
		TypeAttr type;
		Symbol* sym = 0;
		int args = 0;
		int sysCode = 0;
	
#line 1221 "ASTParser.cpp"
	
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case WRITE:
	case WRITELN:
	{
		{
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		switch ( _t->getType()) {
		case WRITE:
		{
			RefASTNodeExt __t191 = _t;
			RefASTNodeExt tmp7_AST_in = _t;
			match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),WRITE);
			_t = _t->getFirstChild();
			if ( inputState->guessing==0 ) {
#line 829 "parser.g"
				sysCode = SYSCODE_WRITE;
#line 1242 "ASTParser.cpp"
			}
			{ // ( ... )*
			for (;;) {
				if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
					_t = ASTNULL;
				if ((_tokenSet_1.member(_t->getType()))) {
					type=expression(_t);
					_t = _retTree;
					if ( inputState->guessing==0 ) {
#line 834 "parser.g"
						
														gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(type.getTypeNameCode())));		// arg type
														++args;
													
#line 1257 "ASTParser.cpp"
					}
				}
				else {
					goto _loop193;
				}
				
			}
			_loop193:;
			} // ( ... )*
			_t = __t191;
			_t = _t->getNextSibling();
			break;
		}
		case WRITELN:
		{
			RefASTNodeExt __t194 = _t;
			RefASTNodeExt tmp8_AST_in = _t;
			match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),WRITELN);
			_t = _t->getFirstChild();
			if ( inputState->guessing==0 ) {
#line 841 "parser.g"
				sysCode = SYSCODE_WRITELN;
#line 1280 "ASTParser.cpp"
			}
			{ // ( ... )*
			for (;;) {
				if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
					_t = ASTNULL;
				if ((_tokenSet_1.member(_t->getType()))) {
					type=expression(_t);
					_t = _retTree;
					if ( inputState->guessing==0 ) {
#line 846 "parser.g"
						
														gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(type.getTypeNameCode())));		// arg type
														++args;
													
#line 1295 "ASTParser.cpp"
					}
				}
				else {
					goto _loop196;
				}
				
			}
			_loop196:;
			} // ( ... )*
			_t = __t194;
			_t = _t->getNextSibling();
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
		}
		}
		}
		if ( inputState->guessing==0 ) {
#line 854 "parser.g"
			
							gen.genAsm(SymbolicInstr(Compiler::SYSCALL, Constant(sysCode), Constant(args)));
						
#line 1320 "ASTParser.cpp"
		}
		break;
	}
	case READ:
	{
		RefASTNodeExt __t197 = _t;
		RefASTNodeExt tmp9_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),READ);
		_t = _t->getFirstChild();
		{ // ( ... )+
		int _cnt199=0;
		for (;;) {
			if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
				_t = ASTNULL;
			if ((_t->getType() == IDENT)) {
				sym=identifier(_t,false);
				_t = _retTree;
				if ( inputState->guessing==0 ) {
#line 862 "parser.g"
					
												gen.genAddressOf(sym);
												gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(sym->type.getTypeNameCode())));		// arg type
												++args;
											
#line 1345 "ASTParser.cpp"
				}
			}
			else {
				if ( _cnt199>=1 ) { goto _loop199; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));}
			}
			
			_cnt199++;
		}
		_loop199:;
		}  // ( ... )+
		_t = __t197;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 870 "parser.g"
			
							gen.genAsm(SymbolicInstr(Compiler::SYSCALL, Constant(SYSCODE_READ), Constant(args)));
						
#line 1363 "ASTParser.cpp"
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	_retTree = _t;
}

void ASTParser::paramList(RefASTNodeExt _t,
	Symbol* fn
) {
	RefASTNodeExt paramList_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
#line 795 "parser.g"
	
		Symbol* sym = 0;
		Symbol::ParamVector params;
	
#line 1384 "ASTParser.cpp"
	
	RefASTNodeExt __t186 = _t;
	RefASTNodeExt tmp10_AST_in = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),PARAMS);
	_t = _t->getFirstChild();
	{ // ( ... )+
	int _cnt188=0;
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_t->getType() == DECL)) {
			sym=declaration(_t,true);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 805 "parser.g"
				
									sym->isLocal = true;
									sym->isParameter = true;
									params.push_back(sym);
								
#line 1405 "ASTParser.cpp"
			}
		}
		else {
			if ( _cnt188>=1 ) { goto _loop188; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));}
		}
		
		_cnt188++;
	}
	_loop188:;
	}  // ( ... )+
	_t = __t186;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 813 "parser.g"
		
					fn->setParams(params);
				
#line 1423 "ASTParser.cpp"
	}
	_retTree = _t;
}

TypeAttr  ASTParser::expression(RefASTNodeExt _t) {
#line 1403 "parser.g"
	TypeAttr type;
#line 1431 "ASTParser.cpp"
	RefASTNodeExt expression_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt orNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt andNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt eqNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt ltNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt gtNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt leNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt geNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt plusNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt minNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt mulNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt divNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt modNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt invNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt negNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1403 "parser.g"
	
		TypeAttr rt;
		Symbol* sym = 0;
		int loc = 0;
	
#line 1453 "ASTParser.cpp"
	
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case OR:
	{
		RefASTNodeExt __t255 = _t;
		orNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),OR);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		rt=expression(_t);
		_t = _retTree;
		_t = __t255;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1413 "parser.g"
			
							ERROR_IF(type != TypeAttr(BOOL) || rt != TypeAttr(BOOL),
										orNode->getLine(), "Cannot apply the '|' operator to a non-boolean value");
			
							gen.genAsm(SymbolicInstr(Compiler::OR)); 
							type = TypeAttr(BOOL);
						
#line 1479 "ASTParser.cpp"
		}
		break;
	}
	case AND:
	{
		RefASTNodeExt __t256 = _t;
		andNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),AND);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		rt=expression(_t);
		_t = _retTree;
		_t = __t256;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1423 "parser.g"
			
							ERROR_IF(type != TypeAttr(BOOL) || rt != TypeAttr(BOOL),
										andNode->getLine(), "Cannot apply the '&' operator to a non-boolean value");
			
							gen.genAsm(SymbolicInstr(Compiler::AND)); 
							type = TypeAttr(BOOL);
						
#line 1504 "ASTParser.cpp"
		}
		break;
	}
	case NEQ:
	{
		RefASTNodeExt __t257 = _t;
		RefASTNodeExt tmp11_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),NEQ);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1434 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1522 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t257;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1441 "parser.g"
			
							gen.generateArithmeticInstr(Compiler::NEQ, type, rt, loc);
							type = TypeAttr(BOOL);
						
#line 1534 "ASTParser.cpp"
		}
		break;
	}
	case EQ:
	{
		RefASTNodeExt __t258 = _t;
		eqNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),EQ);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1449 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1552 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t258;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1456 "parser.g"
			
							gen.generateArithmeticInstr(Compiler::EQ, type, rt, loc);
							type = TypeAttr(BOOL);
						
#line 1564 "ASTParser.cpp"
		}
		break;
	}
	case TK_LT:
	{
		RefASTNodeExt __t259 = _t;
		ltNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),TK_LT);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1464 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1582 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t259;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1471 "parser.g"
			
							ERROR_IF(! type.isNumericOrChar() || ! rt.isNumericOrChar(),
										ltNode->getLine(), "Cannot apply the '<' operator to a non-numeric value");
			
							gen.generateArithmeticInstr(Compiler::LT, type, rt, loc);
							type = TypeAttr(BOOL);
						
#line 1597 "ASTParser.cpp"
		}
		break;
	}
	case GT:
	{
		RefASTNodeExt __t260 = _t;
		gtNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),GT);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1482 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1615 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t260;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1489 "parser.g"
			
							ERROR_IF(! type.isNumericOrChar() || ! rt.isNumericOrChar(),
										gtNode->getLine(), "Cannot apply the '>' operator to a non-numeric value");
			
							gen.generateArithmeticInstr(Compiler::GT, type, rt, loc);
							type = TypeAttr(BOOL);
						
#line 1630 "ASTParser.cpp"
		}
		break;
	}
	case LE:
	{
		RefASTNodeExt __t261 = _t;
		leNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),LE);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1500 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1648 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t261;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1507 "parser.g"
			
							ERROR_IF(! type.isNumericOrChar() || ! rt.isNumericOrChar(),
										leNode->getLine(), "Cannot apply the '<=' operator to a non-numeric value");
			
							gen.generateArithmeticInstr(Compiler::LE, type, rt, loc);
							type = TypeAttr(BOOL);
						
#line 1663 "ASTParser.cpp"
		}
		break;
	}
	case GE:
	{
		RefASTNodeExt __t262 = _t;
		geNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),GE);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1518 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1681 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t262;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1525 "parser.g"
			
							ERROR_IF(! type.isNumericOrChar() || ! rt.isNumericOrChar(),
										geNode->getLine(), "Cannot apply the '>=' operator to a non-numeric value");
			
							gen.generateArithmeticInstr(Compiler::GE, type, rt, loc);
							type = TypeAttr(BOOL);
						
#line 1696 "ASTParser.cpp"
		}
		break;
	}
	case PLUS:
	{
		RefASTNodeExt __t263 = _t;
		plusNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),PLUS);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1536 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1714 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t263;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1543 "parser.g"
			
							ERROR_IF(! type.isNumericOrChar() || ! rt.isNumericOrChar(),
										plusNode->getLine(), "Cannot apply the '+' operator to a non-numeric value");
			
							type = gen.generateArithmeticInstr(Compiler::ADD, type, rt, loc);
						
#line 1728 "ASTParser.cpp"
		}
		break;
	}
	case STAR:
	{
		RefASTNodeExt __t268 = _t;
		mulNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),STAR);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1571 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1746 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t268;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1578 "parser.g"
			
							ERROR_IF(! type.isNumericOrChar() || ! rt.isNumericOrChar(),
										mulNode->getLine(), "Cannot apply the '*' operator to a non-numeric value");
			
							type = gen.generateArithmeticInstr(Compiler::MUL, type, rt, loc);
						
#line 1760 "ASTParser.cpp"
		}
		break;
	}
	case DIVIDE:
	{
		RefASTNodeExt __t269 = _t;
		divNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),DIVIDE);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1588 "parser.g"
			
								loc = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
							
#line 1778 "ASTParser.cpp"
		}
		rt=expression(_t);
		_t = _retTree;
		_t = __t269;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1595 "parser.g"
			
							ERROR_IF(! type.isNumericOrChar() || ! rt.isNumericOrChar(),
										divNode->getLine(), "Cannot apply the '/' operator to a non-numeric value");
			
							type = gen.generateArithmeticInstr(Compiler::DIV, type, rt, loc);
						
#line 1792 "ASTParser.cpp"
		}
		break;
	}
	case MODULO:
	{
		RefASTNodeExt __t270 = _t;
		modNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),MODULO);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		rt=expression(_t);
		_t = _retTree;
		_t = __t270;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1604 "parser.g"
			
							ERROR_IF(type != TypeAttr(INT) || rt != TypeAttr(INT),
										modNode->getLine(), "Cannot apply the '%' operator to a non-integer value");
			
							gen.genAsm(SymbolicInstr(Compiler::MOD));
						
#line 1816 "ASTParser.cpp"
		}
		break;
	}
	case NOT:
	{
		RefASTNodeExt __t272 = _t;
		negNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),NOT);
		_t = _t->getFirstChild();
		type=expression(_t);
		_t = _retTree;
		_t = __t272;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1622 "parser.g"
			
							ERROR_IF(type != TypeAttr(BOOL), negNode->getLine(), "Cannot apply the '~' operator to a non-boolean value");
			
							gen.genAsm(SymbolicInstr(Compiler::NOT));
						
#line 1837 "ASTParser.cpp"
		}
		break;
	}
	case ADDR:
	{
		RefASTNodeExt __t273 = _t;
		RefASTNodeExt tmp12_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),ADDR);
		_t = _t->getFirstChild();
		{
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		switch ( _t->getType()) {
		case IDENT:
		{
			sym=identifier(_t,false);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 1631 "parser.g"
				
										gen.genAddressOf(sym);
				
										type = sym->type;
										type.clearArrayAttributes();		// in case the identifier was an array
										type.increaseRefLevel();
									
#line 1864 "ASTParser.cpp"
			}
			break;
		}
		case LBRACKET:
		{
			type=arrayAccess(_t);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 1641 "parser.g"
				
											// multiply by the object size to get to the right position
											//
											if (getTypeSizeFromTypeName(type.getName()) >= WORD_SIZE) {
												gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(getTypeSizeFromTypeName(type.getName()))));
												gen.genAsm(SymbolicInstr(Compiler::MUL, type.getTypeNameCode()));
											}
											
											gen.genAsm(SymbolicInstr(Compiler::ADD, type.getTypeNameCode()));
											
											// since we took the address of an array index we got a pointer type
											
											type.clearArrayAttributes();		// in case the identifier was an array
											type.increaseRefLevel();
										
#line 1889 "ASTParser.cpp"
			}
			break;
		}
		default:
		{
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
		}
		}
		}
		_t = __t273;
		_t = _t->getNextSibling();
		break;
	}
	case REF:
	{
		type=reference(_t);
		_t = _retTree;
		break;
	}
	case CAST:
	{
		RefASTNodeExt __t275 = _t;
		RefASTNodeExt tmp13_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),CAST);
		_t = _t->getFirstChild();
		type=typeSpec(_t);
		_t = _retTree;
		rt=expression(_t);
		_t = _retTree;
		_t = __t275;
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1663 "parser.g"
			
							if (rt == TypeAttr(INT) && type == TypeAttr(FLOAT)) {
								gen.genAsm(SymbolicInstr(Compiler::ITOF));
							}
							else {
								if (rt == TypeAttr(FLOAT) && type == TypeAttr(INT)) {
									gen.genAsm(SymbolicInstr(Compiler::FTOI));
								}
							}
						
#line 1933 "ASTParser.cpp"
		}
		break;
	}
	case CALL:
	{
		type=functionCall(_t);
		_t = _retTree;
		break;
	}
	case CONST:
	case IDENT:
	case LBRACKET:
	{
		type=primaryExpr(_t);
		_t = _retTree;
		break;
	}
	default:
		bool synPredMatched266 = false;
		if (((_t->getType() == MINUS))) {
			RefASTNodeExt __t266 = _t;
			synPredMatched266 = true;
			inputState->guessing++;
			try {
				{
				RefASTNodeExt __t265 = _t;
				RefASTNodeExt tmp14_AST_in = _t;
				match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),MINUS);
				_t = _t->getFirstChild();
				expression(_t);
				_t = _retTree;
				expression(_t);
				_t = _retTree;
				_t = __t265;
				_t = _t->getNextSibling();
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched266 = false;
			}
			_t = __t266;
			inputState->guessing--;
		}
		if ( synPredMatched266 ) {
			RefASTNodeExt __t267 = _t;
			minNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
			match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),MINUS);
			_t = _t->getFirstChild();
			type=expression(_t);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 1554 "parser.g"
				
										loc = gen.getCodeSize();
										gen.genAsm(SymbolicInstr(Compiler::NOP));		// reserve for possible int-to-float conversion
									
#line 1990 "ASTParser.cpp"
			}
			rt=expression(_t);
			_t = _retTree;
			_t = __t267;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 1561 "parser.g"
				
								ERROR_IF(! type.isNumericOrChar() || ! rt.isNumericOrChar(),
											minNode->getLine(), "Cannot apply the '-' operator to a non-numeric value");
				
								type = gen.generateArithmeticInstr(Compiler::SUB, type, rt, loc);
							
#line 2004 "ASTParser.cpp"
			}
		}
		else if ((_t->getType() == MINUS)) {
			RefASTNodeExt __t271 = _t;
			invNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
			match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),MINUS);
			_t = _t->getFirstChild();
			type=expression(_t);
			_t = _retTree;
			_t = __t271;
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 1613 "parser.g"
				
								ERROR_IF(! type.isNumericOrChar(),
											invNode->getLine(), "Cannot apply unary '-' operator to a non-numeric value");
				
								gen.genAsm(SymbolicInstr(Compiler::NEG, type.getTypeNameCode())); 
							
#line 2024 "ASTParser.cpp"
			}
		}
	else {
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	_retTree = _t;
	return type;
}

Symbol*  ASTParser::identifier(RefASTNodeExt _t,
	bool genCode
) {
#line 2011 "parser.g"
	Symbol* sym = 0;
#line 2040 "ASTParser.cpp"
	RefASTNodeExt identifier_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt id = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt __t295 = _t;
	RefASTNodeExt tmp15_AST_in = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),IDENT);
	_t = _t->getFirstChild();
	id = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),IDENT);
	_t = _t->getNextSibling();
	_t = __t295;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 2016 "parser.g"
		
					sym = findSymbol(id->getText(), scope.getStack());
					
					ERROR_IF(! sym, id->getLine(), "Undefined identifier");
					
					if (genCode) {
						if (sym->type.isArray()) {
							if (sym->isParameter) {
								gen.genAsm(SymbolicInstr(Compiler::LOAD, sym, INT_CODE));	// array parameters are treated as pointers
							}
							else {
								gen.genAsm(SymbolicInstr(Compiler::ICLOAD, sym));		// load the base address of the array
							}
						}
						else {
							gen.genAsm(SymbolicInstr(Compiler::LOAD, sym, sym->type.getStorageClass()));
						}
					}
				
#line 2074 "ASTParser.cpp"
	}
	_retTree = _t;
	return sym;
}

void ASTParser::statementList(RefASTNodeExt _t) {
	RefASTNodeExt statementList_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	
	{ // ( ... )+
	int _cnt207=0;
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_tokenSet_2.member(_t->getType()))) {
			statement(_t);
			_t = _retTree;
		}
		else {
			if ( _cnt207>=1 ) { goto _loop207; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));}
		}
		
		_cnt207++;
	}
	_loop207:;
	}  // ( ... )+
	_retTree = _t;
}

vector<int>  ASTParser::arrayTypeSpec(RefASTNodeExt _t) {
#line 1213 "parser.g"
	vector<int> dim;
#line 2106 "ASTParser.cpp"
	RefASTNodeExt arrayTypeSpec_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt n = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1213 "parser.g"
	
		Constant cns;
	
#line 2113 "ASTParser.cpp"
	
	RefASTNodeExt __t229 = _t;
	RefASTNodeExt tmp16_AST_in = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),ARRAY);
	_t = _t->getFirstChild();
	{ // ( ... )+
	int _cnt231=0;
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_t->getType() == NUMERIC)) {
			n = _t;
			match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),NUMERIC);
			_t = _t->getNextSibling();
			if ( inputState->guessing==0 ) {
#line 1223 "parser.g"
				
									Constant cns = getNumericConstant(n->getText());
									
									ERROR_IF(cns.type != TypeAttr(INT),
												n->getLine(), "Array dimensions must be specified using integer constants");
									
									dim.push_back(cns.intVal);
								
#line 2138 "ASTParser.cpp"
			}
		}
		else {
			if ( _cnt231>=1 ) { goto _loop231; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));}
		}
		
		_cnt231++;
	}
	_loop231:;
	}  // ( ... )+
	_t = __t229;
	_t = _t->getNextSibling();
	_retTree = _t;
	return dim;
}

void ASTParser::incDec(RefASTNodeExt _t) {
	RefASTNodeExt incDec_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt incNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt decNode = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1282 "parser.g"
	
		TypeAttr type;
		Symbol* sym = 0;
	
#line 2164 "ASTParser.cpp"
	
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case INC:
	{
		RefASTNodeExt __t239 = _t;
		incNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),INC);
		_t = _t->getFirstChild();
		{
		bool synPredMatched242 = false;
		if (((_t->getType() == IDENT))) {
			RefASTNodeExt __t242 = _t;
			synPredMatched242 = true;
			inputState->guessing++;
			try {
				{
				identifier(_t);
				_t = _retTree;
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched242 = false;
			}
			_t = __t242;
			inputState->guessing--;
		}
		if ( synPredMatched242 ) {
			sym=identifier(_t,false);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 1292 "parser.g"
				
											ERROR_IF(sym->type != TypeAttr(INT) && sym->type != TypeAttr(Compiler::CHAR),
														incNode->getLine(), "Operator '++' is defined only for integer types");
											
											gen.genAsm(SymbolicInstr(Compiler::INC1, sym));
										
#line 2204 "ASTParser.cpp"
			}
		}
		else {
			bool synPredMatched244 = false;
			if (((_t->getType() == REF))) {
				RefASTNodeExt __t244 = _t;
				synPredMatched244 = true;
				inputState->guessing++;
				try {
					{
					reference(_t);
					_t = _retTree;
					}
				}
				catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
					synPredMatched244 = false;
				}
				_t = __t244;
				inputState->guessing--;
			}
			if ( synPredMatched244 ) {
				type=reference(_t,true, true);
				_t = _retTree;
				if ( inputState->guessing==0 ) {
#line 1301 "parser.g"
					
												ERROR_IF(type != TypeAttr(INT) && type != TypeAttr(Compiler::CHAR),
															incNode->getLine(), "Operator '++' is defined only for integer types");
					
												gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(1)));
												gen.genAsm(SymbolicInstr(Compiler::INCI));
											
#line 2237 "ASTParser.cpp"
				}
			}
			else if ((_tokenSet_1.member(_t->getType()))) {
				type=expression(_t);
				_t = _retTree;
				if ( inputState->guessing==0 ) {
#line 1311 "parser.g"
					
												ERROR_IF(type != TypeAttr(INT) && type != TypeAttr(Compiler::CHAR),
															incNode->getLine(), "Operator '++' is defined only for integer types");
					
												gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(1)));
												gen.genAsm(SymbolicInstr(Compiler::INCI));
											
#line 2252 "ASTParser.cpp"
				}
			}
		else {
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
		}
		}
		}
		_t = __t239;
		_t = _t->getNextSibling();
		break;
	}
	case DEC:
	{
		RefASTNodeExt __t245 = _t;
		decNode = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),DEC);
		_t = _t->getFirstChild();
		{
		bool synPredMatched248 = false;
		if (((_t->getType() == IDENT))) {
			RefASTNodeExt __t248 = _t;
			synPredMatched248 = true;
			inputState->guessing++;
			try {
				{
				identifier(_t);
				_t = _retTree;
				}
			}
			catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
				synPredMatched248 = false;
			}
			_t = __t248;
			inputState->guessing--;
		}
		if ( synPredMatched248 ) {
			sym=identifier(_t,false);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 1325 "parser.g"
				
											ERROR_IF(sym->type != TypeAttr(INT) && sym->type != TypeAttr(Compiler::CHAR),
														decNode->getLine(), "Operator '--' is defined only for integer types");
				
											gen.genAsm(SymbolicInstr(Compiler::DEC1, sym));
										
#line 2299 "ASTParser.cpp"
			}
		}
		else {
			bool synPredMatched250 = false;
			if (((_t->getType() == REF))) {
				RefASTNodeExt __t250 = _t;
				synPredMatched250 = true;
				inputState->guessing++;
				try {
					{
					reference(_t);
					_t = _retTree;
					}
				}
				catch (ANTLR_USE_NAMESPACE(antlr)RecognitionException& pe) {
					synPredMatched250 = false;
				}
				_t = __t250;
				inputState->guessing--;
			}
			if ( synPredMatched250 ) {
				type=reference(_t,true, true);
				_t = _retTree;
				if ( inputState->guessing==0 ) {
#line 1334 "parser.g"
					
												ERROR_IF(type != TypeAttr(INT) && type != TypeAttr(Compiler::CHAR),
															decNode->getLine(), "Operator '--' is defined only for integer types");
					
												gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(1)));
												gen.genAsm(SymbolicInstr(Compiler::DECI));
											
#line 2332 "ASTParser.cpp"
				}
			}
			else if ((_tokenSet_1.member(_t->getType()))) {
				type=expression(_t);
				_t = _retTree;
				if ( inputState->guessing==0 ) {
#line 1344 "parser.g"
					
												ERROR_IF(type != TypeAttr(INT) && type != TypeAttr(Compiler::CHAR),
															decNode->getLine(), "Operator '--' is defined only for integer types");
					
												gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(1)));
												gen.genAsm(SymbolicInstr(Compiler::DECI));
											
#line 2347 "ASTParser.cpp"
				}
			}
		else {
			throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
		}
		}
		}
		_t = __t245;
		_t = _t->getNextSibling();
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	_retTree = _t;
}

void ASTParser::assignment(RefASTNodeExt _t) {
	RefASTNodeExt assignment_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt node = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1358 "parser.g"
	
		Symbol* sym;
		TypeAttr lt, rt;
	
#line 2375 "ASTParser.cpp"
	
	RefASTNodeExt __t252 = _t;
	node = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),ASSIGN);
	_t = _t->getFirstChild();
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case DECL:
	{
		sym=declaration(_t);
		_t = _retTree;
		rt=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1368 "parser.g"
			
									ERROR_IF(! rt.isAssignableTo(sym->type), node->getLine(), "Illegal definition");
			
									gen.genAsm(SymbolicInstr(Compiler::STORE, sym, sym->type.getStorageClass()));
								
#line 2398 "ASTParser.cpp"
		}
		break;
	}
	case LBRACKET:
	{
		lt=arrayAccess(_t);
		_t = _retTree;
		rt=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1376 "parser.g"
			
									ERROR_IF(! rt.isAssignableTo(lt), node->getLine(), "Illegal assignment to array index");
			
									gen.genAsm(SymbolicInstr(Compiler::STOREI, lt.getStorageClass(lt.isPointer())));
								
#line 2415 "ASTParser.cpp"
		}
		break;
	}
	case REF:
	{
		lt=reference(_t,true);
		_t = _retTree;
		rt=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1384 "parser.g"
			
									ERROR_IF(! rt.isAssignableTo(lt), node->getLine(), "Illegal assignment to pointer");
			
									gen.genAsm(SymbolicInstr(Compiler::STOREI0, lt.getStorageClass()));
								
#line 2432 "ASTParser.cpp"
		}
		break;
	}
	case IDENT:
	{
		sym=identifier(_t,false);
		_t = _retTree;
		rt=expression(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1392 "parser.g"
			
									ERROR_IF(! rt.isAssignableTo(sym->type), node->getLine(), "Illegal assignment to identifier");
			
									gen.genAsm(SymbolicInstr(Compiler::STORE, sym, sym->type.getStorageClass()));
								
#line 2449 "ASTParser.cpp"
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	_t = __t252;
	_t = _t->getNextSibling();
	_retTree = _t;
}

TypeAttr  ASTParser::reference(RefASTNodeExt _t,
	bool isLValue, bool genZeroOffset
) {
#line 1823 "parser.g"
	TypeAttr type;
#line 2469 "ASTParser.cpp"
	RefASTNodeExt reference_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt n = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt __t284 = _t;
	n = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),REF);
	_t = _t->getFirstChild();
	type=expression(_t);
	_t = _retTree;
	_t = __t284;
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 1828 "parser.g"
		
					ERROR_IF(! type.isPointer(), n->getLine(), "Cannot dereference a non-pointer value");
		
					// For an L-value we don't want to push the value onto stack - we just
					// want to set it to something, so we don't generate a LOAD instruction
					// in those cases.
					//
					if (! isLValue) {
						gen.genAsm(SymbolicInstr(Compiler::LOADI0, type.getStorageClass()));
					}
		
					// this is used for INCI/DECI instructions
					if (genZeroOffset) {
						gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(0)));
					}
					
					type.reduceRefLevel();
				
#line 2501 "ASTParser.cpp"
	}
	_retTree = _t;
	return type;
}

TypeAttr  ASTParser::arrayAccess(RefASTNodeExt _t) {
#line 1954 "parser.g"
	TypeAttr arrayType;
#line 2510 "ASTParser.cpp"
	RefASTNodeExt arrayAccess_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt b = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1954 "parser.g"
	
		vector<int> arrayLayoutValues;
		size_t lv;
		bool generateAdd = false;
		TypeAttr indexType;
		int dimension = 0;
	
#line 2521 "ASTParser.cpp"
	
	RefASTNodeExt __t291 = _t;
	b = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),LBRACKET);
	_t = _t->getFirstChild();
	arrayType=expression(_t);
	_t = _retTree;
	if ( inputState->guessing==0 ) {
#line 1967 "parser.g"
		
						if (!arrayType.isPointer()) {
							gen.setArrayLayoutValues(arrayType, &arrayLayoutValues);
							lv = arrayLayoutValues.size() - 1;
						}
					
#line 2537 "ASTParser.cpp"
	}
	{ // ( ... )+
	int _cnt293=0;
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_tokenSet_1.member(_t->getType()))) {
			indexType=expression(_t);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 1977 "parser.g"
				
									ERROR_IF(indexType != TypeAttr(INT), b->getLine(), "Array index must be of integer type");
								
									ERROR_IF(! (arrayType.isArray() || arrayType.isIndexablePointer()), b->getLine(), "Illegal array access");
				
									ERROR_IF(arrayType.isPointer() && dimension + 1 > 1, b->getLine(),
												"Pointers cannot be treated as multi-dimensional arrays");
				
									++dimension;
				
									if (!arrayType.isPointer() && arrayType.isArray()) {
										int layoutValue = arrayLayoutValues[lv];
										if (layoutValue > 1) {
											Constant c(layoutValue, TypeAttr(INT));
											gen.genAsm(SymbolicInstr(Compiler::ICLOAD, c));
											gen.genAsm(SymbolicInstr(Compiler::MUL, INT_CODE));
										}
										
										if (generateAdd) {
											gen.genAsm(SymbolicInstr(Compiler::ADD, INT_CODE));
										}
										
										generateAdd = true;
										--lv;
									}
									
									arrayType.reduceArray();
								
#line 2577 "ASTParser.cpp"
			}
		}
		else {
			if ( _cnt293>=1 ) { goto _loop293; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));}
		}
		
		_cnt293++;
	}
	_loop293:;
	}  // ( ... )+
	_t = __t291;
	_t = _t->getNextSibling();
	_retTree = _t;
	return arrayType;
}

TypeAttr  ASTParser::functionCall(RefASTNodeExt _t) {
#line 1694 "parser.g"
	TypeAttr type;
#line 2597 "ASTParser.cpp"
	RefASTNodeExt functionCall_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt fc = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt procName = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
#line 1694 "parser.g"
	
		Symbol* sym = 0;
		bool useReturnValue = true;
		FunctionCall* call = new FunctionCall;
		vector<TypeAttr> argTypes;
	
#line 2608 "ASTParser.cpp"
	
	RefASTNodeExt __t277 = _t;
	fc = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),CALL);
	_t = _t->getFirstChild();
	procName = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),IDENT);
	_t = _t->getNextSibling();
	if ( inputState->guessing==0 ) {
#line 1706 "parser.g"
		
						//sym = findSymbol(procName->getText(), scope.stStack);
						sym = findFunction(procName->getText(), scope);
						
						ERROR_IF(! sym, procName->getLine(), "Undefined function");
		
						if (fc->isTopLevelCall) {
							useReturnValue = false;
						}
						else {	// someone is using the return value - make sure the function is not void
							ERROR_IF(sym->type.getSize() == 0, fc->getLine(), "Function does not return a value");
						}
		
						call->name = sym->name;
		
						// ### save the expression stack pointer
						gen.genAsm(SymbolicInstr(Compiler::PUSHX));
		
						// The return value (if any) is stored at the bottom of the frame
						// because when the function returns the expression stack pointer
						// will be restored such that to include this return value into
						// the previous expression.
		
						// ### make room for the return value (if there is one)
						if (sym->type.getSize() > 0) {
							call->resultSpace = gen.getCodeSize();
							gen.genAsm(SymbolicInstr(Compiler::INCX, Constant(0)));
						}
					
#line 2648 "ASTParser.cpp"
	}
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case ARGS:
	{
		argTypes=args(_t);
		_t = _retTree;
		break;
	}
	case 3:
	{
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	if ( inputState->guessing==0 ) {
#line 1742 "parser.g"
		
						ERROR_IF(!validateFunctionCall(sym, &argTypes), procName->getLine(), "Invalid function call");
		
						// ### make room for local non-parameter data
		
						// With forward calls we don't know what the local space is,
						// otherwise we do, so we can save some time.
						//
						if (sym->isFullFunctionDef) {
							// if the function doesn't have any local non-parameter data then don't generate INCX instruction
							if (sym->localSpace - sym->paramsSpace > 0) {
								call->nonParamSpace = gen.getCodeSize();
								gen.genAsm(SymbolicInstr(Compiler::INCX, Constant(0)));
							}
						}
						else {	// we don't have a full def (it's a forward call) so we can't assume anything
							call->nonParamSpace = gen.getCodeSize();
							gen.genAsm(SymbolicInstr(Compiler::INCX, Constant(0)));
						}
		
						// ### load the return address
						gen.genAsm(SymbolicInstr(Compiler::ICLOAD, Constant(gen.getCodeSize() + 4)));
		
						// ### save the current SP
						gen.genAsm(SymbolicInstr(Compiler::LOADSP));
		
						// ### set the new SP
						gen.genAsm(SymbolicInstr(Compiler::POPXSP));
		
						// ### jump to the function code
						call->targetAddr = gen.getCodeSize();
						gen.genAsm(SymbolicInstr(Compiler::GOTO, Constant(0)));
		
						// the following instructions are executed after the function returns
		
						// ### adjust the expression stack pointer
		
						// If the function's return value is not used we need to adjust
						// the expr. stack pointer accordingly.
						//
						call->restoreX = gen.getCodeSize();
						gen.genAsm(SymbolicInstr(Compiler::DECX, Constant(0)));
						
						// ### load the result (if any and if used) from the current stack to the previous expression stack
						if (sym->type.getSize() > 0 && useReturnValue) {
							call->copyResult = gen.getCodeSize();
							gen.genAsm(SymbolicInstr(Compiler::LOAD, Constant(0), INT_CODE, SymbolicInstr::OPERAND, SymbolicInstr::LOCAL));
						}
						
						// ### restore the previous SP
						call->restoreSP = gen.getCodeSize();
						gen.genAsm(SymbolicInstr(Compiler::SETSP, Constant(0)));
		
						gen.fnCall.push_back(call);
		
						type = sym->type;
					
#line 2729 "ASTParser.cpp"
	}
	_t = __t277;
	_t = _t->getNextSibling();
	_retTree = _t;
	return type;
}

TypeAttr  ASTParser::primaryExpr(RefASTNodeExt _t) {
#line 1850 "parser.g"
	TypeAttr type;
#line 2740 "ASTParser.cpp"
	RefASTNodeExt primaryExpr_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
#line 1850 "parser.g"
	
		Symbol* symbol;
		Constant cns;
	
#line 2747 "ASTParser.cpp"
	
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case IDENT:
	{
		symbol=identifier(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1859 "parser.g"
			
							type = symbol->type;
						
#line 2761 "ASTParser.cpp"
		}
		break;
	}
	case LBRACKET:
	{
		type=postfixExpr(_t);
		_t = _retTree;
		break;
	}
	case CONST:
	{
		cns=constant(_t);
		_t = _retTree;
		if ( inputState->guessing==0 ) {
#line 1867 "parser.g"
			
							type = cns.type;
						
#line 2780 "ASTParser.cpp"
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	_retTree = _t;
	return type;
}

vector<TypeAttr>  ASTParser::args(RefASTNodeExt _t) {
#line 1804 "parser.g"
	vector<TypeAttr> argTypes;
#line 2796 "ASTParser.cpp"
	RefASTNodeExt args_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
#line 1804 "parser.g"
	
		TypeAttr t;
	
#line 2802 "ASTParser.cpp"
	
	RefASTNodeExt __t280 = _t;
	RefASTNodeExt tmp17_AST_in = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),ARGS);
	_t = _t->getFirstChild();
	{ // ( ... )+
	int _cnt282=0;
	for (;;) {
		if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
			_t = ASTNULL;
		if ((_tokenSet_1.member(_t->getType()))) {
			t=expression(_t);
			_t = _retTree;
			if ( inputState->guessing==0 ) {
#line 1814 "parser.g"
				
									argTypes.push_back(t);
								
#line 2821 "ASTParser.cpp"
			}
		}
		else {
			if ( _cnt282>=1 ) { goto _loop282; } else {throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));}
		}
		
		_cnt282++;
	}
	_loop282:;
	}  // ( ... )+
	_t = __t280;
	_t = _t->getNextSibling();
	_retTree = _t;
	return argTypes;
}

TypeAttr  ASTParser::postfixExpr(RefASTNodeExt _t) {
#line 1942 "parser.g"
	TypeAttr type;
#line 2841 "ASTParser.cpp"
	RefASTNodeExt postfixExpr_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	
	type=arrayAccess(_t);
	_t = _retTree;
	if ( inputState->guessing==0 ) {
#line 1947 "parser.g"
		
					gen.genAsm(SymbolicInstr(Compiler::LOADI, type.getStorageClass(type.isPointer())));
				
#line 2851 "ASTParser.cpp"
	}
	_retTree = _t;
	return type;
}

Constant  ASTParser::constant(RefASTNodeExt _t) {
#line 1874 "parser.g"
	Constant cns;
#line 2860 "ASTParser.cpp"
	RefASTNodeExt constant_AST_in = (_t == ASTNULL) ? RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) : _t;
	RefASTNodeExt n = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt s = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	RefASTNodeExt c = RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST);
	
	RefASTNodeExt __t287 = _t;
	RefASTNodeExt tmp18_AST_in = _t;
	match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),CONST);
	_t = _t->getFirstChild();
	{
	if (_t == RefASTNodeExt(ANTLR_USE_NAMESPACE(antlr)nullAST) )
		_t = ASTNULL;
	switch ( _t->getType()) {
	case NUMERIC:
	{
		n = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),NUMERIC);
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1881 "parser.g"
			
									cns = getNumericConstant(n->getText());
									scope.top()->addConstant(cns);
									gen.genConst(cns);
								
#line 2886 "ASTParser.cpp"
		}
		break;
	}
	case STRING:
	{
		s = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),STRING);
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1889 "parser.g"
			
									string str = s->getText();
									
									TypeAttr::DimVector dims;
			
									// subtract 2 for quotes and add 1 for '\0' terminator
									dims.push_back(static_cast<int>(str.size() - 1));
									
									TypeAttr t(Compiler::CHAR, dims);
									t.setAsPointer();
									
									cns.token = str;
									cns.type = t;
									scope.top()->addConstant(cns);
									
									gen.genConst(cns);
								
#line 2914 "ASTParser.cpp"
		}
		break;
	}
	case CHAR:
	{
		c = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),CHAR);
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1909 "parser.g"
			
									cns = Constant(c->getText()[0], TypeAttr(Compiler::CHAR));
									scope.top()->addConstant(cns);
									gen.genConst(cns);
								
#line 2930 "ASTParser.cpp"
		}
		break;
	}
	case TRUE:
	{
		RefASTNodeExt tmp19_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),TRUE);
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1917 "parser.g"
			
									cns = Constant(1, TypeAttr(BOOL));
									gen.genConst(cns);
								
#line 2945 "ASTParser.cpp"
		}
		break;
	}
	case FALSE:
	{
		RefASTNodeExt tmp20_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),FALSE);
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1924 "parser.g"
			
									cns = Constant(0, TypeAttr(BOOL));
									gen.genConst(cns);
								
#line 2960 "ASTParser.cpp"
		}
		break;
	}
	case NULLV:
	{
		RefASTNodeExt tmp21_AST_in = _t;
		match(ANTLR_USE_NAMESPACE(antlr)RefAST(_t),NULLV);
		_t = _t->getNextSibling();
		if ( inputState->guessing==0 ) {
#line 1931 "parser.g"
			
									cns = Constant(0, TypeAttr(INT));
									cns.type.setAsPointer();
									gen.genConst(cns);
								
#line 2976 "ASTParser.cpp"
		}
		break;
	}
	default:
	{
		throw ANTLR_USE_NAMESPACE(antlr)NoViableAltException(ANTLR_USE_NAMESPACE(antlr)RefAST(_t));
	}
	}
	}
	_t = __t287;
	_t = _t->getNextSibling();
	_retTree = _t;
	return cns;
}

void ASTParser::initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& )
{
}
const char* ASTParser::tokenNames[] = {
	"<0>",
	"EOF",
	"<2>",
	"NULL_TREE_LOOKAHEAD",
	"\"program\"",
	"\"true\"",
	"\"false\"",
	"\"null\"",
	"\"return\"",
	"\"loop\"",
	"\"if\"",
	"\"else\"",
	"\"continue\"",
	"\"break\"",
	"\"write\"",
	"\"writeln\"",
	"\"read\"",
	"DECL",
	"TYPE",
	"ARRAY",
	"SCOPE",
	"BLOCK",
	"CAST",
	"DIM",
	"CONST",
	"CALL",
	"FUNCTION",
	"PARAMS",
	"INIT",
	"COND",
	"ITER",
	"LOOPHDR",
	"ARGS",
	"EMPTY",
	"INC",
	"DEC",
	"IDENT",
	"SEMI",
	"LPAREN",
	"RPAREN",
	"LCURLY",
	"COMMA",
	"RCURLY",
	"ASSIGN",
	"LBRACKET",
	"NUMERIC",
	"RBRACKET",
	"REF",
	"INCR",
	"DECR",
	"OR",
	"AND",
	"NEQ",
	"EQ",
	"TK_LT",
	"GT",
	"LE",
	"GE",
	"PLUS",
	"MINUS",
	"STAR",
	"DIVIDE",
	"MODULO",
	"NOT",
	"ADDR",
	"CHAR",
	"STRING",
	"WS",
	"DOT",
	"ARROW",
	"DIRECTIVE",
	"INS_START",
	"INS_END",
	"COMMENT",
	"COMMENT_2",
	"DIGIT",
	"LETTER",
	"FORWARD",
	0
};

const unsigned long ASTParser::_tokenSet_0_data_[] = { 54657024UL, 4294744092UL, 1UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// DECL CAST CONST CALL INC DEC IDENT ASSIGN LBRACKET REF OR AND NEQ EQ 
// TK_LT GT LE GE PLUS MINUS STAR DIVIDE MODULO NOT ADDR 
const ANTLR_USE_NAMESPACE(antlr)BitSet ASTParser::_tokenSet_0(_tokenSet_0_data_,8);
const unsigned long ASTParser::_tokenSet_1_data_[] = { 54525952UL, 4294742032UL, 1UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// CAST CONST CALL IDENT LBRACKET REF OR AND NEQ EQ TK_LT GT LE GE PLUS 
// MINUS STAR DIVIDE MODULO NOT ADDR 
const ANTLR_USE_NAMESPACE(antlr)BitSet ASTParser::_tokenSet_1(_tokenSet_1_data_,8);
const unsigned long ASTParser::_tokenSet_2_data_[] = { 2204366080UL, 4294744092UL, 1UL, 0UL, 0UL, 0UL, 0UL, 0UL };
// "return" "if" "continue" "break" "write" "writeln" "read" DECL BLOCK 
// CAST CONST CALL LOOPHDR INC DEC IDENT ASSIGN LBRACKET REF OR AND NEQ 
// EQ TK_LT GT LE GE PLUS MINUS STAR DIVIDE MODULO NOT ADDR 
const ANTLR_USE_NAMESPACE(antlr)BitSet ASTParser::_tokenSet_2(_tokenSet_2_data_,8);


