#ifndef INC_SourceParser_hpp_
#define INC_SourceParser_hpp_

#include <antlr/config.hpp>
/* $ANTLR 2.7.5 (20050201): "parser.g" -> "SourceParser.hpp"$ */
#include <antlr/TokenStream.hpp>
#include <antlr/TokenBuffer.hpp>
#include "SourceParserTokenTypes.hpp"
#include <antlr/LLkParser.hpp>

#line 10 "parser.g"

	#include <iostream>

	#include "CodeGenerator.h"
	#include "Symbols.h"
	#include "Utilities.h"
	
	using namespace std;
	using namespace Compiler;

#line 23 "SourceParser.hpp"
#line 6 "parser.g"

	#include "ANTLRExt.h"

#line 28 "SourceParser.hpp"
class CUSTOM_API SourceParser : public ANTLR_USE_NAMESPACE(antlr)LLkParser, public SourceParserTokenTypes
{
#line 1 "parser.g"
#line 32 "SourceParser.hpp"
public:
	void initializeASTFactory( ANTLR_USE_NAMESPACE(antlr)ASTFactory& factory );
protected:
	SourceParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf, int k);
public:
	SourceParser(ANTLR_USE_NAMESPACE(antlr)TokenBuffer& tokenBuf);
protected:
	SourceParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer, int k);
public:
	SourceParser(ANTLR_USE_NAMESPACE(antlr)TokenStream& lexer);
	SourceParser(const ANTLR_USE_NAMESPACE(antlr)ParserSharedInputState& state);
	int getNumTokens() const
	{
		return SourceParser::NUM_TOKENS;
	}
	const char* getTokenName( int type ) const
	{
		if( type > getNumTokens() ) return 0;
		return SourceParser::tokenNames[type];
	}
	const char* const* getTokenNames() const
	{
		return SourceParser::tokenNames;
	}
	public: void start();
	public: void declaration();
	public: void paramList();
	public: void functionDef();
	public: void paramTypeList();
	public: void forward();
	public: void block();
	public: void functionDecl();
	public: void typeSpec();
	public: void statement();
	public: void loop();
	public: void ifElse();
	public: void returnExpression();
	public: void simpleStatement();
	public: void expression();
	public: void identifier();
	public: void loopInitializerList();
	public: void loopCondition();
	public: void loopIteration();
	public: void definition();
	public: void arraySpec();
	public: void incDec();
	public: void assign();
	public: void specialUnaryExpr();
	public: void orExpr();
	public: void andExpr();
	public: void logPrimary();
	public: void relExpr();
	public: void additiveExpr();
	public: void multiplicativeExpr();
	public: void unaryExpr();
	public: void postfixExpr();
	public: void primaryExpr();
	public: void call();
	public: void constant();
	public: void args();
public:
	ANTLR_USE_NAMESPACE(antlr)RefAST getAST()
	{
		return ANTLR_USE_NAMESPACE(antlr)RefAST(returnAST);
	}
	
protected:
	RefASTNodeExt returnAST;
private:
	static const char* tokenNames[];
#ifndef NO_STATIC_CONSTS
	static const int NUM_TOKENS = 78;
#else
	enum {
		NUM_TOKENS = 78
	};
#endif
	
	static const unsigned long _tokenSet_0_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_0;
	static const unsigned long _tokenSet_1_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_1;
	static const unsigned long _tokenSet_2_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_2;
	static const unsigned long _tokenSet_3_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_3;
	static const unsigned long _tokenSet_4_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_4;
	static const unsigned long _tokenSet_5_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_5;
	static const unsigned long _tokenSet_6_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_6;
	static const unsigned long _tokenSet_7_data_[];
	static const ANTLR_USE_NAMESPACE(antlr)BitSet _tokenSet_7;
};

#endif /*INC_SourceParser_hpp_*/
